Attribute VB_Name = "Module1"
Option Explicit

Public fMainForm As frmMain
Public fConvertForm As frmConvert
Public fPreferencesForm As frmPreferences
Public bNavigateError As Boolean
Public sNavigateText As String

'============TAB STOPS==============
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
   ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const EM_SETTABSTOPS = &HCB
'============TAB STOPS==============

Global Const MaxTDValues = 200

Global Const TAG_TRACK_START = "<!-- TRACK-START -->"
Global Const TAG_TRACK_END = "<!-- TRACK-END -->"
Global Const TAG_FX_START = "<!-- FX-START -->"
Global Const TAG_FX_END = "<!-- FX-END -->"
Global Const TAG_ITEM_START = "<!-- ITEM-START -->"
Global Const TAG_ITEM_END = "<!-- ITEM-END -->"
Global Const TAG_SEND_START = "<!-- SEND-START -->"
Global Const TAG_SEND_END = "<!-- SEND-END -->"
Global Const TAG_RECEIVE_START = "<!-- RECEIVE-START -->"
Global Const TAG_RECEIVE_END = "<!-- RECEIVE-END -->"

Global iTDCount As Long
Global TDValues(MaxTDValues) As String


Global Const MaxTableCell = 200
Global TableCell(MaxTableCell) As String
Global TableCellCount As Integer
Global TableColumns As Integer

Global sErrorList As String

Type PrefsType
    sReaperLastFileName As String
    sHTMLLastFileName As String
    sTemplateLastFileName As String
    sPrefListSeparator As String        'Space, Comma, Tab, <BR>
    sPrefDateFormat As String           'Short or Long
    sPrefTimeFormat As String           'Short or Long
End Type

Type ProjectType
    pName   As String
    pNotes  As String
    pVersion As String
    pSampleRate As String
    pBeatsPerMinute As Single
    pTimeSig As Integer
    pTimeSig2 As Integer
End Type

Type TrackType
    tName As String
    tPan As Single
    tType As String
    tMute As Boolean
    tSolo As Boolean
    tVolume As Single
    tEffectCount As Integer
    tItemCount As Integer
    tSendRcvCount As Integer
    tIsGroup As Boolean
    tInGroup As Boolean
End Type

Type ItemType
    iPosition As Single
    iLength As Single
    iName As String
    iPan As Single
    iMute As Boolean
    iVolume As Single
    iGroup As Integer
End Type

Type EffectType
    eType As String
    eName As String
    eDLL As String
    eBypass As Boolean
End Type

Type SendRCVType
    sSendRcv As String      'S = Send, R = Receive.  Project file only stores Receives
    sSendTrack As String    'Sending track number (zero based)
    sFade As Integer        '0 = Post Fader, 1 = Pre-FX, 2 = Post-FX
    sVolume As Single
    sPan As Single
    sMute As Boolean
    'sUnknown As String
    'sOtherBool As Boolean
    sAudioFrom As Integer
    sAudioTo As Integer
    'sUnknown2 As Single
    sMidiFromTo As Integer  'low 5 bits = MIDI TO, next 5 bits = MIDI FROM
End Type

Global Const MAX_TRACKS = 1000
Global Const MAX_EFFECTS = 100
Global Const MAX_ITEMS = 500
Global Const MAX_SENDRCV = 500

Global ProjectInfo As ProjectType
Global TrackInfo(MAX_TRACKS) As TrackType
Global EffectInfo(MAX_TRACKS, MAX_EFFECTS) As EffectType
Global ItemInfo(MAX_TRACKS, MAX_ITEMS) As ItemType
Global SendRcvInfo(MAX_TRACKS, MAX_SENDRCV) As SendRCVType

Global Prefs As PrefsType

Global sTab As String

Global TrackCount As Integer
Global EffectCount As Integer
Global ItemCount As Integer
Global SendRcvCount As Integer


Sub Main()
    Set fMainForm = New frmMain
    Set fConvertForm = New frmConvert
    Set fPreferencesForm = New frmPreferences
    'fConvertForm As frmConvert
    
    Call ShowHelp  'display initial page
    
    'fMainForm.WebBrowser1.Navigate (App.Path & "\reaperdoc.htm")
    'fMainForm.WebBrowser1.Navigate ("http://www.greggreno.com/reaperdoc.htm")
    fMainForm.Show
    
    sTab = Chr(9)
End Sub

Sub ShowHelp()
    Dim nRet As Integer

    bNavigateError = False
    fMainForm.WebBrowser1.Navigate (App.Path & "\reaperdoc.htm")
    
    Exit Sub
    
    'fMainForm.WebBrowser1.Navigate ("http://www.greggreno.com/reaperdoc.htm")

    'if there is no helpfile for this project display a message to the user
    'you can set the HelpFile for your application in the
    'Project Properties dialog
    'If Len(App.HelpFile) = 0 Then
    '    MsgBox "Unable to display Help Contents. There is no Help associated with this project.", vbInformation, Me.Caption
    'Else
    '    On Error Resume Next
    '    nRet = OSWinHelp(Me.hwnd, App.HelpFile, 3, 0)
    '    If Err Then
    '        MsgBox Err.Description
    '    End If
    'End If
    If fMainForm.WebBrowser1.LocationName <> "ReaperDoc" Then fMainForm.WebBrowser1.Navigate (App.Path & "\reaperdoc.htm")
End Sub


Function ReadProjectFile(sFilename As String) As Boolean
    Dim i As Integer
    Dim s As String
    Dim bInNotes As Boolean
    Dim bInProject As Boolean
    Dim bInTrack As Boolean
    Dim bInItem As Boolean
    Dim bInGroup As Boolean
    Dim bIsGroup As Boolean
    Dim iTemp As Integer
    
    Dim sQuotedString As String
    Dim sQuotedString2 As String
    Dim bBypass As Boolean
    
    TrackCount = 0
    EffectCount = 0
    
    For i = 1 To MAX_TRACKS
        TrackInfo(i).tEffectCount = 0
        TrackInfo(i).tItemCount = 0
        TrackInfo(i).tSendRcvCount = 0
    Next i
    
    ProjectInfo.pName = ""
    ProjectInfo.pNotes = ""
    ProjectInfo.pVersion = ""
    
    
    bInNotes = False
    bInProject = False
    bInTrack = False
    bInItem = False
    bInGroup = False
    
    'On Error GoTo ImportColError
    
    'Open the file
    Open sFilename For Input As #3
    ProjectInfo.pName = sFilename
    
    Line Input #3, s
    While EOF(3) = False
    
        s = RTrim(LTrim(s))
        
        'Call RTFText(s & Chr(13))
        
        'Parse words
        Call GetWords(s)
        sQuotedString = GetQuotedString(s, 1)
        sQuotedString2 = GetQuotedString(s, 2)
        
        If iTDCount > 0 Then
        
            'Project Level info
            If TDValues(1) = "<REAPER_PROJECT" Then
                bInProject = True
                bInTrack = False
                bInNotes = False
                bIsGroup = False
                ProjectInfo.pVersion = TDValues(2)
            
            'Item
            ElseIf TDValues(1) = "<ITEM" Then
                bInItem = True
                TrackInfo(TrackCount).tItemCount = TrackInfo(TrackCount).tItemCount + 1
            
            'Mute/bypass
            ElseIf TDValues(1) = "BYPASS" Then
                bBypass = NumToBool(ToInt(TDValues(2)))
                
            'Group?
            ElseIf TDValues(1) = "ISBUS" Then
                iTemp = ToInt(TDValues(2))
                bIsGroup = False
                If iTemp = 1 Then
                    bIsGroup = True
                    bInGroup = False
                End If
                
                TrackInfo(TrackCount).tIsGroup = bIsGroup
                TrackInfo(TrackCount).tInGroup = bInGroup
                
                If iTemp = 1 Then bInGroup = True   'Following tracks are in group
                If iTemp = 2 Then bInGroup = False  'Following tracks are not in group
                
            'Track start
            ElseIf TDValues(1) = "<TRACK" Then
                bInProject = False
                bInTrack = True
                bInNotes = False
                EffectCount = 0
                If TrackCount < 500 Then TrackCount = TrackCount + 1
                Call ClearTrack(TrackCount)
                'TrackInfo(TrackCount).tEffectCount = 0
                'TrackInfo(TrackCount).tItemCount = 0
                'TrackInfo(TrackCount).tSendRcvCount = 0
                
            'End notes or item
            ElseIf TDValues(1) = ">" Then
                bInNotes = False
                bInItem = False
                
            'Accumulate notes
            ElseIf bInNotes = True Then
                If ProjectInfo.pNotes <> "" Then ProjectInfo.pNotes = ProjectInfo.pNotes & "<br>"
                ProjectInfo.pNotes = ProjectInfo.pNotes & s
            
            'Item tags
            ElseIf bInItem = True Then
                'Skip anything in item
                If TDValues(1) = "POSITION" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iPosition = ToSingle(TDValues(2))
                ElseIf TDValues(1) = "LENGTH" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iLength = ToSingle(TDValues(2))
                ElseIf TDValues(1) = "MUTE" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iMute = NumToBool(ToInt(TDValues(2)))
                ElseIf TDValues(1) = "GROUP" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iGroup = ToInt(TDValues(2))
                ElseIf TDValues(1) = "NAME" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iName = sQuotedString
                ElseIf TDValues(1) = "VOLPAN" Then
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iVolume = TDValues(2)
                    ItemInfo(TrackCount, TrackInfo(TrackCount).tItemCount).iPan = TDValues(3)
                End If
                
            'Project tags
            ElseIf bInProject = True Then
                If TDValues(1) = "<NOTES" Then
                    bInNotes = True
                    
                ElseIf TDValues(1) = "SAMPLERATE" Then
                    ProjectInfo.pSampleRate = TDValues(2)
                    
                ElseIf TDValues(1) = "TEMPO" Then
                    ProjectInfo.pBeatsPerMinute = TDValues(2)
                    ProjectInfo.pTimeSig = TDValues(3)
                    ProjectInfo.pTimeSig2 = TDValues(4)
                    
                End If
                
            'Track Level Info
            ElseIf bInTrack = True Then
                If TDValues(1) = "NAME" Then
                    'TrackInfo(TrackCount).tName = ReplaceString(TDValues(2), Chr(34), "")
                    TrackInfo(TrackCount).tName = sQuotedString
                    
                ElseIf TDValues(1) = "VOLPAN" Then
                    TrackInfo(TrackCount).tVolume = TDValues(2)
                    TrackInfo(TrackCount).tPan = TDValues(3)
                
                ElseIf TDValues(1) = "AUXRECV" Then
                    TrackInfo(TrackCount).tSendRcvCount = TrackInfo(TrackCount).tSendRcvCount + 1
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sSendRcv = "R"    'Receive
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sSendTrack = ToInt(TDValues(2)) + 1
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sFade = TDValues(3)
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sVolume = TDValues(4)
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sPan = TDValues(5)
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sMute = NumToBool(ToInt(TDValues(6)))
                    'SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).??? = ToInt(TDValues(7))
                    'SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).??? = ToInt(TDValues(8))
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sAudioFrom = ToInt(TDValues(9))
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sAudioTo = ToInt(TDValues(10))
                    'SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).??? = ToInt(TDValues(11))
                    SendRcvInfo(TrackCount, TrackInfo(TrackCount).tSendRcvCount).sMidiFromTo = ToInt(TDValues(12))
                    
                    Call AddSend(TrackCount, TrackInfo(TrackCount).tSendRcvCount)
                    
                ElseIf TDValues(1) = "MUTESOLO" Then
                    TrackInfo(TrackCount).tMute = NumToBool(ToInt(TDValues(2)))
                    TrackInfo(TrackCount).tSolo = NumToBool(ToInt(TDValues(3)))
                    
                ElseIf TDValues(1) = "<VST" Or TDValues(1) = "<DX" Or TDValues(1) = "<JS" Then
                    TrackInfo(TrackCount).tEffectCount = TrackInfo(TrackCount).tEffectCount + 1
                    EffectInfo(TrackCount, TrackInfo(TrackCount).tEffectCount).eName = sQuotedString   'first quoted string is the name
                    EffectInfo(TrackCount, TrackInfo(TrackCount).tEffectCount).eDLL = sQuotedString2   'second quoted string is the file name
                    EffectInfo(TrackCount, TrackInfo(TrackCount).tEffectCount).eType = Mid(TDValues(1), 2, 999)
                    EffectInfo(TrackCount, TrackInfo(TrackCount).tEffectCount).eBypass = bBypass
                End If
            
            End If
        End If
        
        
        Line Input #3, s
    Wend


    
SkipRemaining:
    Close #3
    On Error GoTo 0
    Exit Function

ImportColError:
    MsgBox "Read Error"
    On Error GoTo 0
    
End Function

'Turn a Receive from one track into a send on another track
Sub AddSend(FromTrack As Integer, FromRcv As Integer)
    Dim ToTrack As Integer
    Dim ToRcv As Integer
    
    ToTrack = SendRcvInfo(FromTrack, FromRcv).sSendTrack
    
    TrackInfo(ToTrack).tSendRcvCount = TrackInfo(ToTrack).tSendRcvCount + 1
    ToRcv = TrackInfo(ToTrack).tSendRcvCount
    SendRcvInfo(ToTrack, ToRcv) = SendRcvInfo(FromTrack, FromRcv)
    SendRcvInfo(ToTrack, ToRcv).sSendRcv = "S"
    SendRcvInfo(ToTrack, ToRcv).sSendTrack = FromTrack
    

End Sub




'Format the project info into RTF format
Sub FormatProjectFile(sFilename As String, sTemplateFileName)

    Dim iPos As Long
    Dim iPos2 As Long
    Dim iPosFXStart As Long
    Dim iPosFXEnd As Long
    Dim s As String
    
    Dim sTemplate As String
    
    Dim sOutHeader As String
    Dim sOutTrackHeader As String
    Dim sOutTrackFooter As String
    Dim sOutTrack As String
    Dim sInTrack As String
    Dim sOutFooter As String
    
    Dim sInFX As String
    Dim sOutFX As String
    Dim sTemp As String
    
    Const IFSTRING = "(#IF"
    Const ELSESTRING = "##ELSE"
    Const ENDIFSTRING = "##END-IF#)"
    Dim iIfPos As Integer
    Dim iElsePos As Integer
    Dim iEndIfPos As Integer
    Dim iConditionLen As String
    Dim sIfChunk As String
    Dim sElseChunk As String
    Dim sCondition As String
    Dim sIfThenElseChunk As String
    Dim sFirstPart As String
    Dim sEndPart As String
    Dim bCondition As Boolean
    
    Dim sOutPage As String
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim resp
    
    If FileExists(sFilename) Then
        resp = MsgBox("The file " & sFilename & " already exists.  Do you want to overwrite it?", vbOKCancel, "Overwrite file?")
        If resp <> vbOK Then Exit Sub
    End If
    
    'Read Template File
    'sTemplateFileName = App.Path & "\templates\default_template.htm"
    sTemplate = ReadFile(sTemplateFileName)
    
    'Replace project level info
    sOutPage = sTemplate
    sOutPage = ReplaceString(sOutPage, "##FILE-NAME##", ProjectInfo.pName)
    sOutPage = ReplaceString(sOutPage, "##TEMPLATE-NAME##", sTemplateFileName)
    sOutPage = ReplaceString(sOutPage, "##OUTPUT-NAME##", sFilename)
    sOutPage = ReplaceString(sOutPage, "##VERSION##", ProjectInfo.pVersion)
    sOutPage = ReplaceString(sOutPage, "##TEMPO##", ProjectInfo.pBeatsPerMinute & " BPM " & ProjectInfo.pTimeSig & "/" & ProjectInfo.pTimeSig2)
    sOutPage = ReplaceString(sOutPage, "##SAMPLE-RATE##", ProjectInfo.pSampleRate)
    sOutPage = ReplaceString(sOutPage, "##NOTES##", ReplaceString(ProjectInfo.pNotes, "|", ""))
    sOutPage = ReplaceString(sOutPage, "##DATE##", GetDate())
    sOutPage = ReplaceString(sOutPage, "##TIME##", GetTime())

    
    'Separate out the track info
    iPos = 1
    iPos = InStr(iPos, sOutPage, TAG_TRACK_START, vbTextCompare)
    If (iPos > 0) Then
        sOutHeader = Left(sOutPage, iPos - 1)
        iPos = iPos + Len(TAG_TRACK_START)
        
        iPos2 = InStr(iPos, sOutPage, TAG_TRACK_END, vbTextCompare)
        If (iPos2 > 0) Then
            sInTrack = Mid(sOutPage, iPos, iPos2 - iPos)
            'MsgBox sInTrack
            iPos2 = iPos2 + Len(TAG_TRACK_END)
            sOutFooter = Mid(sOutPage, iPos2, 999999)
            
            'Loop through all the tracks
            For i = 1 To TrackCount
                sOutTrack = sInTrack
                
                'Handle If Then Else structure
                iIfPos = InStr(1, sOutTrack, IFSTRING)
                iElsePos = InStr(1, sOutTrack, ELSESTRING)
                iEndIfPos = InStr(1, sOutTrack, ENDIFSTRING)
                
                While (iIfPos > 0)
                  If (iIfPos > 0 And iElsePos > 0 And iEndIfPos > 0 And iElsePos > iIfPos And iEndIfPos > iElsePos) Then
                    sFirstPart = Left(sOutTrack, iIfPos - 1)
                    sEndPart = Mid(sOutTrack, iEndIfPos + Len(ENDIFSTRING), 99999)
                    sIfThenElseChunk = Mid(sOutTrack, iIfPos + Len(IFSTRING), (iEndIfPos - iIfPos) - Len(IFSTRING))
                    
                    'Now get condition, if chunk and else chunk
                    iConditionLen = 0
                    If Left(sIfThenElseChunk, Len("-IS-GROUP")) = "-IS-GROUP" Then iConditionLen = Len("-IS-GROUP")
                    If Left(sIfThenElseChunk, Len("-IN-GROUP")) = "-IN-GROUP" Then iConditionLen = Len("-IN-GROUP")
                    If Left(sIfThenElseChunk, Len("-IS-MUTED")) = "-IS-MUTED" Then iConditionLen = Len("-IS-MUTED")
                    
                    'Test condition
                    If iConditionLen > 0 Then
                        sCondition = Left(sIfThenElseChunk, iConditionLen)
                        iIfPos = iConditionLen + 1
                        iElsePos = InStr(1, sIfThenElseChunk, ELSESTRING)
                        sIfChunk = Mid(sIfThenElseChunk, iIfPos, iElsePos - iIfPos)
                        sElseChunk = Mid(sIfThenElseChunk, iElsePos + Len(ELSESTRING), 9999)
                        
                        bCondition = False
                        If sCondition = "-IS-GROUP" And TrackInfo(i).tIsGroup = True Then bCondition = True
                        If sCondition = "-IN-GROUP" And TrackInfo(i).tInGroup = True Then bCondition = True
                        If sCondition = "-IS-MUTED" And TrackInfo(i).tMute = True Then bCondition = True
                        
                        If bCondition = True Then
                            sOutTrack = sFirstPart & sIfChunk & sEndPart
                        Else
                            sOutTrack = sFirstPart & sElseChunk & sEndPart
                        End If
                    Else
                        sOutTrack = "##Invalid If-Then-Else format## " & sOutTrack
                        iIfPos = 0
                    End If
                  Else
                    If iIfPos > 0 Or iElsePos > 0 Or iEndIfPos > 0 Then
                        sOutTrack = "##Invalid If-Then-Else format## " & sOutTrack
                    End If
                    iIfPos = 0
                    
                  End If
                
                  iIfPos = InStr(1, sOutTrack, IFSTRING)
                  iElsePos = InStr(1, sOutTrack, ELSESTRING)
                  iEndIfPos = InStr(1, sOutTrack, ENDIFSTRING)

                Wend
                
                'MsgBox sOutTrack
                sOutTrack = ReplaceString(sOutTrack, "##TRACK-NUM##", i)
                sOutTrack = ReplaceString(sOutTrack, "##TRACK-NAME##", TrackInfo(i).tName)
                sOutTrack = ReplaceString(sOutTrack, "##VOLUME##", FormatVol(TrackInfo(i).tVolume))
                sOutTrack = ReplaceString(sOutTrack, "##PAN##", FormatPan(TrackInfo(i).tPan))
                sOutTrack = ReplaceString(sOutTrack, "##MUTE##", FormatIfTrue(TrackInfo(i).tMute, "Mute"))
                sOutTrack = ReplaceString(sOutTrack, "##SOLO##", FormatIfTrue(TrackInfo(i).tSolo, "Solo"))
                sOutTrack = ReplaceString(sOutTrack, "##FX-LIST##", GetFXList(i))
                sOutTrack = ReplaceString(sOutTrack, "##ITEM-LIST##", GetItemList(i))
                sOutTrack = ReplaceString(sOutTrack, "##SEND-LIST##", GetSendList(i))
                sOutTrack = ReplaceString(sOutTrack, "##RCV-LIST##", GetRcvList(i))
                sOutTrack = ReplaceString(sOutTrack, "##IS-GROUP##", FormatIfTrue(TrackInfo(i).tIsGroup, "Is Group"))
                sOutTrack = ReplaceString(sOutTrack, "##IN-GROUP##", FormatIfTrue(TrackInfo(i).tInGroup, "In Group"))
                
                
                'GoTo skipit
                
                '----EFFECTS----
                'MsgBox sOutTrack
                iPosFXStart = 1
                iPosFXStart = InStr(iPosFXStart, sOutTrack, TAG_FX_START, vbTextCompare)
                If (iPosFXStart > 0) Then
                    sOutTrackHeader = Left(sOutTrack, iPosFXStart - 1)
                    iPosFXStart = iPosFXStart + Len(TAG_FX_START)
        
                    iPosFXEnd = InStr(iPosFXStart, sOutTrack, TAG_FX_END, vbTextCompare)
                    If (iPosFXEnd > 0) Then
                        sInFX = Mid(sOutTrack, iPosFXStart, iPosFXEnd - iPosFXStart)
                        'MsgBox sInTrack
                        iPosFXEnd = iPosFXEnd + Len(TAG_FX_END)
                        sOutTrackFooter = Mid(sOutTrack, iPosFXEnd, 999999)
                    Else
                        sOutTrackFooter = Mid(sOutTrack, iPosFXStart, 99999)
                    End If
                
                    'Loop through all the effects
                    For j = 1 To TrackInfo(i).tEffectCount
                        sOutFX = sInFX
                        sTemp = j
                        'MsgBox sOutFX
                        sOutFX = ReplaceString(sOutFX, "##FX-NUM##", sTemp)
                        sOutFX = ReplaceString(sOutFX, "##FX-NAME##", EffectInfo(i, j).eName)
                        sOutFX = ReplaceString(sOutFX, "##FX-DLL##", EffectInfo(i, j).eDLL)
                        sOutFX = ReplaceString(sOutFX, "##FX-TYPE##", EffectInfo(i, j).eType)
                        sOutFX = ReplaceString(sOutFX, "##FX-ACTIVE##", FormatIfFalse(EffectInfo(i, j).eBypass, "Active"))
                    
                        sOutTrackHeader = sOutTrackHeader & sOutFX
                    Next j
                    sOutTrack = sOutTrackHeader & sOutTrackFooter
                End If
                
                '----ITEMS----
                'MsgBox sOutTrack
                iPosFXStart = 1
                iPosFXStart = InStr(iPosFXStart, sOutTrack, TAG_ITEM_START, vbTextCompare)
                If (iPosFXStart > 0) Then
                    sOutTrackHeader = Left(sOutTrack, iPosFXStart - 1)
                    iPosFXStart = iPosFXStart + Len(TAG_ITEM_START)
       
                    iPosFXEnd = InStr(iPosFXStart, sOutTrack, TAG_ITEM_END, vbTextCompare)
                    If (iPosFXEnd > 0) Then
                        sInFX = Mid(sOutTrack, iPosFXStart, iPosFXEnd - iPosFXStart)
                        'MsgBox sInTrack
                        iPosFXEnd = iPosFXEnd + Len(TAG_ITEM_END)
                        sOutTrackFooter = Mid(sOutTrack, iPosFXEnd, 999999)
                    Else
                        sOutTrackFooter = Mid(sOutTrack, iPosFXStart, 99999)
                    End If
                
                    'Loop through all the items
                    For j = 1 To TrackInfo(i).tItemCount
                        sOutFX = sInFX
                        sTemp = j
                        'MsgBox sOutFX
                        sOutFX = ReplaceString(sOutFX, "##ITEM-NUM##", sTemp)
                        sOutFX = ReplaceString(sOutFX, "##ITEM-NAME##", ItemInfo(i, j).iName)
                        sOutFX = ReplaceString(sOutFX, "##ITEM-POS##", FormatSeconds(ItemInfo(i, j).iPosition))
                        sOutFX = ReplaceString(sOutFX, "##ITEM-LEN##", FormatSeconds(ItemInfo(i, j).iLength))
                        sOutFX = ReplaceString(sOutFX, "##ITEM-GROUP##", ItemInfo(i, j).iGroup)
                        sOutFX = ReplaceString(sOutFX, "##ITEM-MUTE##", FormatIfTrue(ItemInfo(i, j).iMute, "Mute"))
                        sOutFX = ReplaceString(sOutFX, "##ITEM-VOLUME##", FormatVol(ItemInfo(i, j).iVolume))
                        sOutFX = ReplaceString(sOutFX, "##ITEM-PAN##", FormatPan(ItemInfo(i, j).iPan))
                   
                        sOutTrackHeader = sOutTrackHeader & sOutFX
                    Next j
                    sOutTrack = sOutTrackHeader & sOutTrackFooter
                End If
                    
                '----SENDS----
                'MsgBox sOutTrack
                iPosFXStart = 1
                iPosFXStart = InStr(iPosFXStart, sOutTrack, TAG_SEND_START, vbTextCompare)
                If (iPosFXStart > 0) Then
                    sOutTrackHeader = Left(sOutTrack, iPosFXStart - 1)
                    iPosFXStart = iPosFXStart + Len(TAG_SEND_START)
       
                    iPosFXEnd = InStr(iPosFXStart, sOutTrack, TAG_SEND_END, vbTextCompare)
                    If (iPosFXEnd > 0) Then
                        sInFX = Mid(sOutTrack, iPosFXStart, iPosFXEnd - iPosFXStart)
                        'MsgBox sInTrack
                        iPosFXEnd = iPosFXEnd + Len(TAG_SEND_END)
                        sOutTrackFooter = Mid(sOutTrack, iPosFXEnd, 999999)
                    Else
                        sOutTrackFooter = Mid(sOutTrack, iPosFXStart, 99999)
                    End If
                
                    'Loop through all the sends
                    k = 0
                    For j = 1 To TrackInfo(i).tSendRcvCount
                        k = k + 1
                        sOutFX = sInFX
                        sTemp = j
                        If SendRcvInfo(i, k).sSendRcv = "S" Then
                            sOutFX = ReplaceString(sOutFX, "##SEND-NUM##", k)
                            sOutFX = ReplaceString(sOutFX, "##SEND-TRACK-NUM##", SendRcvInfo(i, k).sSendTrack)
                            sOutFX = ReplaceString(sOutFX, "##SEND-TRACK-NAME##", TrackInfo(SendRcvInfo(i, j).sSendTrack).tName)
                            sOutFX = ReplaceString(sOutFX, "##SEND-MUTE##", FormatIfTrue(SendRcvInfo(i, j).sMute, "Mute"))
                            sOutFX = ReplaceString(sOutFX, "##SEND-VOLUME##", FormatVol(SendRcvInfo(i, j).sVolume))
                            sOutFX = ReplaceString(sOutFX, "##SEND-PAN##", FormatPan(SendRcvInfo(i, j).sPan))
                            sOutTrackHeader = sOutTrackHeader & sOutFX
                        End If
                    Next j
                    sOutTrack = sOutTrackHeader & sOutTrackFooter
                End If
                
                
                '----RECEIVES----
                'MsgBox sOutTrack
                iPosFXStart = 1
                iPosFXStart = InStr(iPosFXStart, sOutTrack, TAG_RECEIVE_START, vbTextCompare)
                If (iPosFXStart > 0) Then
                    sOutTrackHeader = Left(sOutTrack, iPosFXStart - 1)
                    iPosFXStart = iPosFXStart + Len(TAG_RECEIVE_START)
       
                    iPosFXEnd = InStr(iPosFXStart, sOutTrack, TAG_RECEIVE_END, vbTextCompare)
                    If (iPosFXEnd > 0) Then
                        sInFX = Mid(sOutTrack, iPosFXStart, iPosFXEnd - iPosFXStart)
                        'MsgBox sInTrack
                        iPosFXEnd = iPosFXEnd + Len(TAG_RECEIVE_END)
                        sOutTrackFooter = Mid(sOutTrack, iPosFXEnd, 999999)
                    Else
                        sOutTrackFooter = Mid(sOutTrack, iPosFXStart, 99999)
                    End If
                
                    'Loop through all the sends
                    k = 0
                    For j = 1 To TrackInfo(i).tSendRcvCount
                        k = k + 1
                        sOutFX = sInFX
                        sTemp = j
                        If SendRcvInfo(i, k).sSendRcv = "R" Then
                            sOutFX = ReplaceString(sOutFX, "##RCV-NUM##", k)
                            sOutFX = ReplaceString(sOutFX, "##RCV-TRACK-NUM##", SendRcvInfo(i, k).sSendTrack)
                            sOutFX = ReplaceString(sOutFX, "##RCV-TRACK-NAME##", TrackInfo(SendRcvInfo(i, j).sSendTrack).tName)
                            sOutFX = ReplaceString(sOutFX, "##RCV-MUTE##", FormatIfTrue(SendRcvInfo(i, j).sMute, "Mute"))
                            sOutFX = ReplaceString(sOutFX, "##RCV-VOLUME##", FormatVol(SendRcvInfo(i, j).sVolume))
                            sOutFX = ReplaceString(sOutFX, "##RCV-PAN##", FormatPan(SendRcvInfo(i, j).sPan))
                            sOutTrackHeader = sOutTrackHeader & sOutFX
                        End If
                    Next j
                    sOutTrack = sOutTrackHeader & sOutTrackFooter
                End If
                
skipit:
                sOutHeader = sOutHeader & sOutTrack
                
                
            Next i
            
            
        Else
            sOutFooter = Mid(sOutPage, iPos, 999999)
        End If
    Else
        sOutHeader = sOutPage
        sOutFooter = ""
    End If
    
    sOutPage = sOutHeader & sOutFooter
    Call WriteFile(sOutPage, sFilename)
    fMainForm.WebBrowser1.Navigate (sFilename)


End Sub
Sub ClearTrack(i As Integer)
    
    TrackInfo(i).tName = ""
    TrackInfo(i).tPan = 0
    TrackInfo(i).tType = ""
    TrackInfo(i).tMute = False
    TrackInfo(i).tSolo = False
    TrackInfo(i).tVolume = 0
    'TrackInfo(i).tEffectCount = 0
    'TrackInfo(i).tItemCount = 0
    'TrackInfo(i).tSendRcvCount = 0
    
End Sub

Function GetFXList(iTrack As Integer) As String
    Dim iIndex As Integer
    Dim iCount As Integer
    Dim i As Integer
    Dim sOut As String
    Dim sSep As String
    
    sOut = ""
    sSep = GetSeperator()
    
    iCount = TrackInfo(iTrack).tEffectCount
    For i = 1 To iCount
        If i > 1 Then sOut = sOut & sSep
        sOut = sOut & EffectInfo(iTrack, i).eName
    Next i
    GetFXList = sOut

End Function

Function GetItemList(iTrack As Integer) As String
    Dim iIndex As Integer
    Dim iCount As Integer
    Dim i As Integer
    Dim sOut As String
    Dim sSep As String
    
    sOut = ""
    sSep = GetSeperator()
    
    iCount = TrackInfo(iTrack).tItemCount
    For i = 1 To iCount
        If i > 1 Then sOut = sOut & sSep
        sOut = sOut & ItemInfo(iTrack, i).iName
    Next i
    GetItemList = sOut

End Function

Function GetSendList(iTrack As Integer) As String
    Dim iIndex As Integer
    Dim iCount As Integer
    Dim i As Integer
    Dim j As Integer
    Dim sOut As String
    Dim sSep As String
    
    sOut = ""
    sSep = GetSeperator()
    
    iCount = TrackInfo(iTrack).tSendRcvCount
    For i = 1 To iCount
        j = 0
        If SendRcvInfo(iTrack, i).sSendRcv = "S" Then
            j = j + 1
            If i > 1 Then sOut = sOut & sSep
            sOut = sOut & "Trk " & SendRcvInfo(iTrack, i).sSendTrack & ":" & TrackInfo(SendRcvInfo(iTrack, i).sSendTrack).tName
        End If
    Next i
    GetSendList = sOut

End Function

Function GetRcvList(iTrack As Integer) As String
    Dim iIndex As Integer
    Dim iCount As Integer
    Dim i As Integer
    Dim j As Integer
    Dim sOut As String
    Dim sSep As String
    
    sOut = ""
    sSep = GetSeperator()
    
    iCount = TrackInfo(iTrack).tSendRcvCount
    For i = 1 To iCount
        j = 0
        If SendRcvInfo(iTrack, i).sSendRcv = "R" Then
            j = j + 1
            If i > 1 Then sOut = sOut & sSep
            sOut = sOut & "Trk " & SendRcvInfo(iTrack, i).sSendTrack & ":" & TrackInfo(SendRcvInfo(iTrack, i).sSendTrack).tName
        End If
    Next i
    GetRcvList = sOut

End Function



Function GetSeperator() As String
    If Prefs.sPrefListSeparator = "<BR>" Then
        GetSeperator = "<BR>"
    ElseIf Prefs.sPrefListSeparator = "Space" Then
        GetSeperator = " "
    ElseIf Prefs.sPrefListSeparator = "Tab" Then
        GetSeperator = Chr(9)
    ElseIf Prefs.sPrefListSeparator = "Comma" Then
        GetSeperator = ","
    Else
        GetSeperator = ", "
    End If
    
End Function


Function GetDate() As String
    If Prefs.sPrefDateFormat = "Short" Then
        GetDate = FormatDateTime(Now(), vbShortDate)
    Else
        GetDate = FormatDateTime(Now(), vbLongDate)
    End If
End Function

Function GetTime() As String
    If Prefs.sPrefTimeFormat = "Short" Then
        GetTime = FormatDateTime(Now(), vbShortTime)
    Else
        GetTime = FormatDateTime(Now(), vbLongTime)
    End If
End Function

Function FormatSeconds(v As Single) As String
    Dim vMinutes As Integer
    Dim vSeconds As Integer
    Dim s As String
    Dim dateIn As Date
    Dim dateOut As Date
    
    
    dateOut = DateAdd("s", v, dateIn)
    s = Format(dateOut, "h:mm:ss")
    
    FormatSeconds = s
End Function
Function ToInt(s As String) As Integer
    Dim i As Integer
    If IsNumeric(s) Then
        i = s
    Else
        i = 0
    End If
    ToInt = i
End Function
Function ToSingle(s As String) As Single
    Dim i As Single
    If IsNumeric(s) Then
        i = s
    Else
        i = 0
    End If
    ToSingle = i
End Function


Function FormatIfTrue(b As Boolean, s As String) As String
    If b = True Then
        FormatIfTrue = s
    Else
        FormatIfTrue = ""
    End If
End Function

Function FormatIfFalse(b As Boolean, s As String) As String
    If b = False Then
        FormatIfFalse = s
    Else
        FormatIfFalse = ""
    End If
End Function

Function FormatPan(v As Single) As String
    If v = 0 Then
        FormatPan = "C"
    ElseIf v < 0 Then
        FormatPan = "L " & Format(-v * 100, "##0") & "%"
    Else
        FormatPan = "R " & Format(v * 100, "##0") & "%"
    End If
End Function

Function FormatVol(v As Single) As String
    Dim l As Double
    Dim c As Double
    
    'volume value has  a range of -71db to + 24db.  Value in V ranges from 0 to 16 where 1 = +0db
    
    If (v = 0) Then
        FormatVol = "-inf"
    Else
        c = 24 / Log(16)
        l = c * Log(v)
        If (l > 0) Then
            FormatVol = Format(l, "+##0.00") & "db"
        Else
            FormatVol = Format(l, "##0.00") & "db"
        End If
    End If
    
End Function


Static Function Log10(x)
   Log10 = Log(x) / Log(10#)
End Function



Function NumToBool(i As Integer) As Boolean
    If i = 1 Then
        NumToBool = True
    Else
        NumToBool = False
    End If
End Function
'================================================
'================================================
'================================================
'================================================
'================================================
'================================================

'============== HANDLING =================
Function FileExists(FileName) As Boolean
   FileExists = (Dir(FileName) <> "")
End Function

'write a string to a file
Sub WriteFile(s As String, sFilename)

    'Open sFileName For Output Access Write As #7
    Open sFilename For Output As #7
    Print #7, s
    Close #7
    

End Sub

Function ReadFile(sFilename) As String

    Dim s As String
    
    'Open sFileName For Output Access Write As #7
    'Open sFileName For Input As #7
    'readln #7, , s
    'Close #7
    
    Dim fso As New FileSystemObject, txtfile, fil1 As File, ts As TextStream
    Set fil1 = fso.GetFile(sFilename)
    ' Read the contents of the file.
    Set ts = fil1.OpenAsTextStream(ForReading)
    s = ts.ReadAll
    ts.Close
    ReadFile = s

End Function

'============== STRING HANDLING ===============
'Skip to a string
Function SkipTo(sFull As String, sSubstr As String, iStart As Long) As Long

    Dim iPos As Long
    
    iPos = InStr(iStart, sFull, sSubstr, 1)
    
    'MsgBox Len(sFull)
    SkipTo = iPos
    
End Function
'Convert Space character to %20
Function ConvertSpaces(sIn As String) As String

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    
    l = Len(sIn)
    For i = 1 To l
        c = Mid$(sIn, i, 1)
        If (c = " ") Then
            sOut = sOut & "%20"
        Else
            sOut = sOut & c
        End If
    
    Next i
    
    ConvertSpaces = sOut

End Function
'Strip out all non numeric characters
Function ConvertToNumber(sIn As String, iMin As Integer, iMax As Integer) As String

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    Dim iAsc As Integer
    If sIn = "" Then
        ConvertToNumber = iMin
        Exit Function
    End If
    Dim iVal As Integer
    
    l = Len(sIn)
    For i = 1 To l
        c = Mid$(sIn, i, 1)
        iAsc = Asc(c)
        'If (iAsc >= 48 And iAsc <= 57) Or c = "-" Then
        If (iAsc >= 48 And iAsc <= 57) Or c = "-" Then
            sOut = sOut & c
        End If
    
    Next i
    If sOut = "" Then sOut = iMin
    If sOut = "-" Then sOut = "-1"
    iVal = sOut
    If iVal > iMax Then sOut = iMax
    If iVal < iMin Then sOut = iMin
    ConvertToNumber = sOut

End Function

Function GetValues(s As String, sSeparator As String) As Integer  'breaks up sentence into words

    Dim iPos As Long
    Dim iEnd As Long
    Dim sOut As String
    Dim sRight As String
    Dim sLeft As String
    Dim sTD As String
    Dim sValue As String
    Dim c As String
    

    sOut = TrimExtraSpaces(s)
    'Call WriteFile(s, "c:\before.txt")
    'Call WriteFile(sOut, "c:\after.txt")
    'sOut = s
    
    iTDCount = 0
    TDValues(1) = ""
    TDValues(2) = ""
    TDValues(3) = ""
    TDValues(4) = ""
    TDValues(5) = ""
    TDValues(6) = ""
    TDValues(7) = ""

    iPos = 1
    iEnd = 1

    While (iPos > 0 And iPos <= Len(sOut) And iTDCount < MaxTDValues)
        iEnd = InStr(iPos, sOut, sSeparator, vbTextCompare)
        If iEnd <= 0 Then iEnd = 99999
        
        'Get the string between the spaces
        sTD = RTrim(LTrim(Mid$(sOut, iPos, iEnd - iPos)))

        iTDCount = iTDCount + 1
        TDValues(iTDCount) = sTD
        
        iPos = iEnd + 1
                
    
    Wend
    
    GetValues = iTDCount
    
End Function

Function CombineTDValues(iStart As Integer) As String

    Dim i As Integer
    Dim s As String
    
    s = ""
    
    For i = iStart To iTDCount
        s = s & TDValues(i) & " "
    Next i
    RTrim (LTrim(s))
    CombineTDValues = s
End Function


'Get rid of extra spaces in a string
Function TrimExtraSpaces(s As String) As String

    Dim S1 As String
    Dim s2 As String
    'Continually remove two spaces with one space until there are no more double spaces
    
    S1 = RTrim(LTrim(s))
    s2 = ReplaceString(S1, "  ", " ")
    While (S1 <> s2)
        S1 = s2
        s2 = ReplaceString(S1, "  ", " ")
    Wend
    
    TrimExtraSpaces = s2
    
End Function

'Second method of breaking up a string into separate values
Function GetValues2(s As String, sSeparator As String) As Integer

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    Dim iCharVal As Integer

    
    l = Len(s)
    iTDCount = 0
    sOut = ""
    
    For i = 1 To l
        c = Mid$(s, i, 1)
        iCharVal = Asc(c)
        If (c = sSeparator) Then
            If iTDCount < MaxTDValues Then
                iTDCount = iTDCount + 1
                TDValues(iTDCount) = sOut
            End If
            sOut = ""
        Else
            sOut = sOut & c
        End If
    
    Next i
    
    If sOut <> "" And iTDCount < MaxTDValues Then
        iTDCount = iTDCount + 1
        TDValues(iTDCount) = sOut
    End If
    
    GetValues2 = iTDCount

End Function

'Just get number from initial characters as long as it's numeric
Function GetInitialNumber(s As String) As Integer

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer

    
    l = Len(s)
    iTDCount = 0
    sOut = ""
    
    For i = 1 To l
        c = Mid$(s, i, 1)
        If IsNumeric(c) = True Then
            sOut = sOut & c
        Else
            Exit For
        End If
    
    Next i
    
    If sOut <> "" Then
        iTDCount = iTDCount + 1
        TDValues(iTDCount) = sOut
    End If
    
    GetInitialNumber = iTDCount

End Function

'Like get values, but separators are spaces, commas and periods
Function GetWords(s As String) As Integer

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    Dim iCharVal As Integer

    
    l = Len(s)
    iTDCount = 0
    sOut = ""
    
    For i = 1 To l
        c = Mid$(s, i, 1)
        iCharVal = Asc(c)
        'If (c = " " Or c = "," Or c = ".") Then
        If (c = " ") Then
            If iTDCount < MaxTDValues Then
                iTDCount = iTDCount + 1
                TDValues(iTDCount) = sOut
            End If
            sOut = ""
        Else
            sOut = sOut & c
        End If
    
    Next i
    
    If sOut <> "" And iTDCount < MaxTDValues Then
        iTDCount = iTDCount + 1
        TDValues(iTDCount) = sOut
    End If
    
    GetWords = iTDCount

End Function



'Same as GetValues2, but will keep items in quotes as one value
Function GetValuesWithQuotes(s As String, sSeparator As String) As Integer

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    Dim iCharVal As Integer
    Dim bInQuote As Boolean

    
    l = Len(s)
    iTDCount = 0
    sOut = ""
    bInQuote = False
    
    For i = 1 To l
        c = Mid$(s, i, 1)
        iCharVal = Asc(c)
        If iCharVal = 34 Then
            If bInQuote = True Then
                bInQuote = False
            Else
                bInQuote = True
            End If
        ElseIf (c = sSeparator And bInQuote = False) Then
            If iTDCount < MaxTDValues Then
                iTDCount = iTDCount + 1
                TDValues(iTDCount) = sOut
            End If
            sOut = ""
        Else
            sOut = sOut & c
        End If
    
    Next i
    
    If sOut <> "" And iTDCount < MaxTDValues Then
        iTDCount = iTDCount + 1
        TDValues(iTDCount) = sOut
    End If
    
    GetValuesWithQuotes = iTDCount

End Function

Function GetQuotedString(s As String, iStringNum As Integer) As String

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    Dim iCharVal As Integer
    Dim bInQuote As Boolean
    Dim iCurrStringNum As Integer
    
    l = Len(s)
    sOut = ""
    bInQuote = False
    
    iCurrStringNum = 0
    
    For i = 1 To l
        c = Mid$(s, i, 1)
        iCharVal = Asc(c)
        If iCharVal = 34 Then
            If bInQuote = True Then
                bInQuote = False
                If iCurrStringNum = iStringNum Then Exit For
            Else
                bInQuote = True
                sOut = ""
                iCurrStringNum = iCurrStringNum + 1
            End If
        ElseIf (bInQuote = True And iCurrStringNum = iStringNum) Then
            sOut = sOut & c
        End If
    
    Next i
    
    GetQuotedString = sOut

End Function


'Strip out special characters like carriage returns and line feeds
Function StripSpecialChars(s As String) As String
    Dim iPos As Long
    Dim sOut As String
    Dim iLen As Long
    Dim sChar As String
    Dim iChar As Integer
    
    sOut = ""
    iPos = 1
    iLen = Len(s)
    While (iPos <= iLen)
        sChar = Mid$(s, iPos, 1)
        iChar = Asc(sChar)
        If (iChar > 13) Then
            sOut = sOut & sChar
        End If
        iPos = iPos + 1
    Wend
    
    StripSpecialChars = sOut
    

End Function

'Strip Tags from an HTML string (everything between brackets)
Function StripTags(s As String) As String

    Dim iPos As Long
    Dim iEnd As Long
    Dim sOut As String
    Dim sRight As String
    Dim sLeft As String
    
    sOut = s
    
    iPos = 1
    iPos = InStr(iPos, sOut, "<", vbTextCompare)
    While (iPos > 0 And iPos < Len(sOut))
        
        'Get the left part
        sLeft = Left$(sOut, iPos - 1)
        
        'Get the right part
        iEnd = InStr(iPos + 1, sOut, ">", vbTextCompare)
        If iEnd <= 0 Or iEnd > Len(sOut) Then iEnd = 99999
        sRight = Mid$(sOut, iEnd + 1, 99999)
        
        'Put them together
        sOut = sLeft & sRight
        
        iPos = 1
        iPos = InStr(iPos, sOut, "<", vbTextCompare)
    
    Wend
    
    StripTags = sOut
    
End Function


'Replace one string with another
Function ReplaceString(s As String, sFrom As String, ByVal sTo As String) As String

    Dim iPos As Long
    Dim sOut As String
    Dim vLen As Long
    Dim sRight As String
    Dim sLeft As String
    
    sOut = s
    vLen = Len(sFrom)
    
    iPos = 1
    iPos = InStr(iPos, sOut, sFrom, vbTextCompare)
    While (iPos > 0 And iPos <= Len(sOut))
        sRight = Left$(sOut, iPos - 1)
        sLeft = Mid$(sOut, iPos + vLen, 9999)
        sOut = sRight & sTo & sLeft
        
        iPos = iPos + 1
        iPos = InStr(1, sOut, sFrom, vbTextCompare)
        'iPos = InStr(iPos, sOut, sFrom, vbTextCompare)
    
    Wend
    
    ReplaceString = sOut
    
End Function

'Convert Single Quotes to two single quotes
Function ConvertQuotes(sIn As String) As String

    Dim sOut As String
    Dim c As String
    Dim l As Integer
    Dim i As Integer
    
    l = Len(sIn)
    For i = 1 To l
        c = Mid$(sIn, i, 1)
        If (c = "'") Then
            sOut = sOut & "''"
        Else
            sOut = sOut & c
        End If
    
    Next i
    
    ConvertQuotes = sOut

End Function

'========================== RTF Functions ============================
Sub RTFNew()
    fMainForm.WebBrowser1.Text = ""
End Sub

Sub RTFTabs(iTabCount As Integer, iTabWidth As Integer)
    Dim x As Integer
    
    'Columns:  "Track Name"   "Volume"  "Pan"   "Mute"  "Solo"
    fMainForm.WebBrowser1.SelTabCount = 5
    fMainForm.WebBrowser1.SelTabs(0) = 0
    fMainForm.WebBrowser1.SelTabs(1) = 2000
    fMainForm.WebBrowser1.SelTabs(2) = 1000
    fMainForm.WebBrowser1.SelTabs(3) = 1000
    fMainForm.WebBrowser1.SelTabs(4) = 1000
    
    
    Call SendMessage(fMainForm.WebBrowser1.hwnd, EM_SETTABSTOPS, 2, 2000)


    
    
    
    'With fMainForm.WebBrowser1
    '  .SelTabCount = iTabCount
    '  For x = 0 To .SelTabCount - 1
    '     .SelTabs(x) = iTabWidth * x
    '  Next x
    'End With
    
End Sub

Sub RTFText(s As String)
    fMainForm.WebBrowser1.SelText = s
End Sub

Sub RTFBold(b As Boolean)
    fMainForm.WebBrowser1.SelBold = b
End Sub

Sub RTFItalic(b As Boolean)
    fMainForm.WebBrowser1.SelItalic = b
End Sub

Sub RTFUnderline(b As Boolean)
    fMainForm.WebBrowser1.SelUnderline = b
End Sub

Sub RTFColor(c)
    fMainForm.WebBrowser1.SelColor = c
End Sub

Sub RTFAlignment(i As Integer)
    fMainForm.WebBrowser1.SelAlignment = i
End Sub

Sub RTFFont(sFont As String, iFontSize As Integer)
    fMainForm.WebBrowser1.SelFontName = sFont
    fMainForm.WebBrowser1.SelFontSize = iFontSize

End Sub

'========================= ERROR FILE HANDLING ========================

Sub InitErrorList()
    sErrorList = ""
End Sub

Sub AddErrorToList(s)
    If sErrorList <> "" Then sErrorList = sErrorList & Chr(13) & Chr(10)
    sErrorList = sErrorList & s
End Sub

Sub SaveErrorList()
    Call WriteFile(sErrorList, "C:\gw_errors.txt")

End Sub
Sub ShowErrorList()
    Dim sApp As String
    Dim RetVal
    
    sApp = "notepad.exe " & "C:\gw_errors.txt"
    RetVal = Shell(sApp, 1)

End Sub
