; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "ReaperDoc"
!define PRODUCT_VERSION "1.0.6"
!define PRODUCT_PUBLISHER "Gregg Reno"
!define PRODUCT_WEB_SITE "http://www.greggreno.com/reaperdoc.htm"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\ReaperDoc.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page

; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\ReaperDoc.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "ReaperDocSetup.exe"
InstallDir "$PROGRAMFILES\ReaperDoc"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "ReaperDoc.exe"
  File "reaperdoc.htm"
  CreateDirectory "$SMPROGRAMS\ReaperDoc"
  CreateShortCut "$SMPROGRAMS\ReaperDoc\ReaperDoc.lnk" "$INSTDIR\ReaperDoc.exe"
  CreateShortCut "$DESKTOP\ReaperDoc.lnk" "$INSTDIR\ReaperDoc.exe"
  SetOutPath "$INSTDIR\templates"
  File "templates\default_template.htm"
  File "templates\more_details_template.htm"
  File "templates\list_template.htm"
  File "templates\CSV_Excel_Template.txt"
SectionEnd

!include Library.nsh

 Var ALREADY_INSTALLED

 Section "-Install VB6 runtimes"

   ;Add code here that sets $ALREADY_INSTALLED to a non-zero value if the application is already installed. For example:

   IfFileExists "$INSTDIR\ReaperDoc.exe" 0 new_installation ;Replace MyApp.exe with your application filename
     StrCpy $ALREADY_INSTALLED 1
   new_installation:

   !insertmacro InstallLib DLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\Mscomctl.ocx" "$SYSDIR\Mscomctl.ocx" "$SYSDIR"
   !insertmacro InstallLib DLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\COMDLG32.OCX" "$SYSDIR\COMDLG32.OCX" "$SYSDIR"
   !insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\msvbvm60.dll" "$SYSDIR\msvbvm60.dll" "$SYSDIR"
   !insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\oleaut32.dll" "$SYSDIR\oleaut32.dll" "$SYSDIR"
   !insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\olepro32.dll" "$SYSDIR\olepro32.dll" "$SYSDIR"
   !insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\comcat.dll"   "$SYSDIR\comcat.dll"   "$SYSDIR"
   !insertmacro InstallLib DLL    $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\asycfilt.dll" "$SYSDIR\asycfilt.dll" "$SYSDIR"
   !insertmacro InstallLib TLB    $ALREADY_INSTALLED REBOOT_NOTPROTECTED "c:\windows\system32\stdole2.tlb"  "$SYSDIR\stdole2.tlb"  "$SYSDIR"

 SectionEnd


Section -AdditionalIcons
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\ReaperDoc\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\ReaperDoc\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\ReaperDoc.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\ReaperDoc.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "ReaperDoc was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove ReaperDoc and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\templates\more_details_template.htm"
  Delete "$INSTDIR\templates\default_template.htm"
  Delete "$INSTDIR\templates\list_template.htm"
  Delete "$INSTDIR\templates\CSV_Excel_Template.txt"

  Delete "$INSTDIR\ReaperDoc.exe"
  Delete "$INSTDIR\reaperdoc.htm"

  Delete "$SMPROGRAMS\ReaperDoc\Uninstall.lnk"
  Delete "$SMPROGRAMS\ReaperDoc\Website.lnk"
  Delete "$DESKTOP\ReaperDoc.lnk"
  Delete "$SMPROGRAMS\ReaperDoc\ReaperDoc.lnk"

  RMDir "$SMPROGRAMS\ReaperDoc"
  RMDir "$INSTDIR\templates"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd

Section "-un.Uninstall VB6 runtimes"

   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SysDir\COMDLG32.OCX"
   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SysDir\Mscomctl.ocx"
   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\msvbvm60.dll"
   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\oleaut32.dll"
   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\olepro32.dll"
   !insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\comcat32.dll"
   !insertmacro UnInstallLib DLL    SHARED NOREMOVE "$SYSDIR\asycfilt.dll"
   !insertmacro UnInstallLib TLB    SHARED NOREMOVE "$SYSDIR\stdole2.tlb"

SectionEnd
